Subject: Re: [PATCH] igb: add module param to set max-rss-queues.

From: Stephen Hemminger <[email-masked]>
Date: Fri, 24 Mar 2017 16:14:57 -0700

On Fri, 24 Mar 2017 14:20:56 -0700
Ben Greear <[email-masked]> wrote:

> On 03/24/2017 02:12 PM, David Miller wrote:
> > From: [email-masked]
> > Date: Fri, 24 Mar 2017 13:58:47 -0700
> >  
> >> From: Ben Greear <[email-masked]>
> >>
> >> In systems where you may have a very large number of network
> >> adapters, certain drivers may consume an unfair amount of
> >> IRQ resources.  So, allow a module param that will limit the
> >> number of IRQs at driver load time.  This way, other drivers
> >> (40G Ethernet, for instance), which probably will need the
> >> multiple IRQs more, will not be starved of IRQ resources.
> >>
> >> Signed-off-by: Ben Greear <[email-masked]>  
> >
> > Sorry, no module params.
> >
> > Use generic run-time facilities such as ethtool to configure
> > such things.  
> 
> You cannot call ethtool before module load time, and that is when
> the IRQs are first acquired.  It may be way more useful to give each
> of 20 network adapters 2 irqs than have the first few grab 16 and the rest
> get lumped into legacy crap.

Almost all network devices do not acquire interrupts until device is brought up.
I.e request_irq is called from open not probe. This is done so that configuration
can be done and also so that unused ports don't consume interrupt space.